/**
* 
* Copyright (C) 2004-2008 FhG Fokus
*
* This file is part of the FhG Fokus UPnP stack - an open source UPnP implementation
* with some additional features
*
* You can redistribute the FhG Fokus UPnP stack and/or modify it
* under the terms of the GNU General Public License Version 3 as published by
* the Free Software Foundation.
*
* For a license to use the FhG Fokus UPnP stack software under conditions
* other than those described here, or to purchase support for this
* software, please contact Fraunhofer FOKUS by e-mail at the following
* addresses:
*   upnpstack@fokus.fraunhofer.de
*
* The FhG Fokus UPnP stack is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, see <http://www.gnu.org/licenses/>
* or write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*
*/
package de.fraunhofer.fokus.upnp.core.examples.gui_control_point.plugins;

import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.Insets;

import javax.swing.JPanel;

import de.fraunhofer.fokus.upnp.core.control_point.CPStateVariable;
import de.fraunhofer.fokus.upnp.core.examples.sensors.SensorConstants;
import de.fraunhofer.fokus.upnp.util.swing.ButtonConstants;
import de.fraunhofer.fokus.upnp.util.swing.SmoothBooleanValueButton;

/**
 * This plugin is used for button services.
 * 
 * @author Alexander Koenig
 */

public class ButtonServicePlugin extends BaseCPServicePlugin
{

  private static final long        serialVersionUID = 1L;

  public static String             PLUGIN_TYPE      = SensorConstants.BUTTON_SERVICE_TYPE;

  private SmoothBooleanValueButton stateButton;

  private JPanel                   contentPanel;

  /*
   * (non-Javadoc)
   * 
   * @see de.fhg.fokus.magic.upnp.examples.gui_control_point.plugins.BasePlugin#initPluginComponents()
   */
  public void initPluginComponents()
  {
    super.initPluginComponents();
    initComponents();

    setBackground(ButtonConstants.BACKGROUND_COLOR);
    contentPanel = new JPanel();
    contentPanel.setBackground(ButtonConstants.BACKGROUND_COLOR);

    stateButton =
      new SmoothBooleanValueButton(new Dimension(370, 2 * ButtonConstants.BUTTON_HEIGHT), 20, "Zustand", "false", null);
    stateButton.setSelectable(false);
    stateButton.setDisabledButtonColor(stateButton.getButtonColor());

    // initialize panel layout
    updateLayout();
  }

  /*
   * (non-Javadoc)
   * 
   * @see de.fhg.fokus.magic.upnp.examples.gui_control_point.plugins.BasePlugin#startPlugin()
   */
  public void startPlugin()
  {
    super.startPlugin();
    try
    {
      stateButton.setState(service.getCPStateVariable("CurrentState").getBooleanValue());
    } catch (Exception ex)
    {
      System.out.println("An error occured:" + ex.getMessage());
    }
  }

  /** Retrieves the type of the plugin */
  public String getPluginType()
  {
    return PLUGIN_TYPE;
  }

  /**
   * This method is called from within the constructor to initialize the form. WARNING: Do NOT
   * modify this code. The content of this method is always regenerated by the Form Editor.
   */
  private void initComponents()// GEN-BEGIN:initComponents
  {
    setLayout(new java.awt.GridBagLayout());

    setBackground(new java.awt.Color(204, 204, 255));

  }// GEN-END:initComponents

  public void stateVariableChanged(CPStateVariable csv)
  {
    if (service.getCPStateVariable("CurrentState") == csv)
    {
      System.out.println("Set new value for button state");
      // set value
      try
      {
        stateButton.setState(csv.getBooleanValue());
      } catch (Exception ex)
      {
      }
    }
  }

  /** Redraws the layout of the plugin */
  private void updateLayout()
  {
    removeAll();

    GridBagConstraints gridBagConstraints;
    contentPanel.setLayout(new java.awt.GridBagLayout());

    gridBagConstraints = new GridBagConstraints();
    gridBagConstraints.fill = GridBagConstraints.BOTH;
    gridBagConstraints.gridx = 0;
    gridBagConstraints.gridy = 0;
    gridBagConstraints.gridwidth = 2;
    gridBagConstraints.insets = new Insets(2, 5, 2, 5);
    contentPanel.add(stateButton, gridBagConstraints);

    buildCenteredLayout(contentPanel);

    repaint();
    validateTree();
  }
}
